#include<c8051f340.h> 
#include<TFT.h>
#include<delay.h>
#include<C8051F340.h>               
//#define SYSCLK       48000000          // Internal oscillator frequency in Hz
#define max_freq 108000 
#define min_freq 87500 
#define min_pll 0x299d

sbit scl=P3^0; 
sbit sda=P3^1;  
sbit s0=P3^2;
sbit s1=P3^3;
sbit s2=P3^4;
sbit s3=P3^5;

unsigned int iic_delay_time = 60; 
unsigned char DISPLAY[14]=" FM: 000.0MHZ";                   
unsigned char radio_write_data[5];
unsigned char radio_read_data[5];             //TEA5767״̬ 
unsigned int  pll; 
unsigned long frequency; 

// delay 
void iic_delay(unsigned int m) 
{ 
     unsigned int n; 
     for(n=0;n<m;n++); 
} 
//I2CߵĺsclΪߵƽʱʹsdaһ  
void iic_start()  
{ 
     sda=1; 
     scl=1; 
     iic_delay(iic_delay_time); 
     sda=0; 
     iic_delay(iic_delay_time); 
     scl=0; 
     iic_delay(iic_delay_time/2); 
} 

//ֹI2CߣsclΪߵƽʱʹsdaһ 
void iic_stop()  
{ 
     sda=0; 
     scl=1; 
     iic_delay(iic_delay_time); 
     sda=1; 
     iic_delay(iic_delay_time); 
} 

//Ӧź 
void iic_ack(void)  
{ 
     sda=0; 
     scl=1; 
     scl=0; 
     sda=1; 
} 	 

//ȴӦź 
bit waitack(void) 
{ 
    unsigned char errtime=255;//ϽշACKʱֵΪ255 
    sda=1; 
    iic_delay(iic_delay_time); 
    while(sda) 
    { 
        errtime--; 
        if (!errtime)         //Ӧʱ˳
        { 
        iic_stop();  
        return 0;             //Ӧ𷵻0
        } 
    } 
    scl=1; 
    iic_delay(iic_delay_time); 
    scl=0; 
    return 1; 				  //Ӧ򷵻1
} 

//һֽ 
void iic_write8bit(unsigned char input)  
{ 
     unsigned char temp; 
     for(temp=0;temp<8;temp++)  
     { 
        if((input<<temp)&0x80) 
            sda=1; 
        else 
            sda=0; 
        
		//һ
		scl=1; 
        iic_delay(iic_delay_time); 
        scl=0; 	             //ʱӵ½д
     } 
} 

//һֽ 
unsigned char iic_read8bit(void)  
{ 
    unsigned char temp,rbyte=0; 
    for(temp=0;temp<8;temp++)  
    { 
        scl=1; 
        iic_delay(iic_delay_time); 
        if(sda) 
            rbyte=(rbyte<<1)+1; 
        else 
            rbyte=rbyte<<1; 
        scl=0; 
    } 
    return(rbyte); 
} 

/********************************/ 
//ƵʼPLL 
void get_pll(void) 
{ 
     unsigned char hlsi; 
     unsigned int twpll=0; 
     hlsi=radio_write_data[2]&0x10; 
     if (hlsi) 
        pll=(unsigned int)((float)((frequency+225)*4)/(float)32.768);    //Ƶʵλ:k 
     else 
        pll=(unsigned int)((float)((frequency-225)*4)/(float)32.768);    //Ƶʵλ:k 
} 
//PLLƵ 
void get_frequency(void) 
{ 
     unsigned char hlsi; 
     unsigned int npll=0; 
     npll=pll; 
     hlsi=radio_write_data[2]&0x10; 
     if (hlsi) 
        frequency=(unsigned long)((float)(npll)*(float)8.192-225);    //Ƶʵλ:KHz 
     else 
        frequency=(unsigned long)((float)(npll)*(float)8.192+225);    //Ƶʵλ:KHz 
} 
//д5767 
//˳Ϊ: ַ  ֽ1  ֽ2 ֽ3 ֽ4 ֽ5  
void radio_write(void) 
{ 
     unsigned char i; 
     iic_start(); 		         //
     iic_write8bit(0xc0);        //дTEA5767ַ 
     waitack();                  //ȴӦź
     for(i=0;i<5;i++)            //д5ֽ
     { 
         iic_write8bit(radio_write_data[i]); 
         waitack();    
     }  
     iic_stop();     	        //ֹͣ
} 

//TEA5767״̬,תƵ 
void radio_read(void) 
{ 
     unsigned char i; 
     unsigned char temp_l,temp_h; 
     pll=0; 
     iic_start();                //
     iic_write8bit(0xc1);        //дTEA5767ַ 
     waitack(); 		         //ȵӦź
     
     for(i=0;i<5;i++) 	         //5ֽ
     { 
        radio_read_data[i]=iic_read8bit(); 
        iic_ack(); 				 
     } 
     
     iic_stop(); 		          //ֹͣ
     temp_l=radio_read_data[1]; 
     temp_h=radio_read_data[0]; 
     temp_h&=0x3f; 
     pll=temp_h*256+temp_l; 
     get_frequency(); 
} 

//EEPROMĶд
void write_24c(unsigned char addr,unsigned char dat)
{
	 iic_start();
	 iic_write8bit(0xa0);
	 waitack();
	 iic_write8bit(addr);
	 waitack();
	 iic_write8bit(dat);
	 waitack();
	 iic_stop();
}
unsigned int read_24c(unsigned char addr)
{
     unsigned char  du;
	 iic_start();
	 iic_write8bit(0xa0);
	 waitack();
	 iic_write8bit(addr);
	 waitack();
	 iic_start();
	 iic_write8bit(0xa1);
	 waitack();
	 du=iic_read8bit();
	 iic_stop();
	 return du;
}

//Զ̨
void auto_search()
{
    radio_read();
    get_pll();
//    if(mode)
        radio_write_data[2]=0xa0;
//    else
//        radio_write_data[2]=0x20;    
    radio_write_data[0]=pll/256+0x40;
    radio_write_data[1]=pll%256;    
    radio_write_data[3]=0x11;
    radio_write_data[4]=0x00;
    radio_write();
    radio_read();
    while(!(radio_read_data[0]&0x80))     //̨ɹ־
    {
        radio_read();

    }    
}
//---------------fmʱ--------------------------------------- 
void OSCILLATOR_Init1(void)
{
     FLSCL     = 0x80;  //ĳ0x80
    CLKMUL    = 0x00;  //ĳ0x00  ֹʱӳ˷

    CLKSEL    = 0x00; //ĳ0x00  ʹڲ ʹ4ʱӳ˷
    OSCICN    = 0x83;  //  ڲʱ ϵͳʱƵʵڲʱƵ  
}
//-----------------------------------------------------------------------------
void display_chang(void)
{
     DISPLAY[5]=frequency/100000 + '0';
	 DISPLAY[6]=(frequency%100000)/10000 + '0';
	 DISPLAY[7]=(frequency%10000)/1000 + '0';
	 DISPLAY[9]=(frequency%1000)/100 + '0';
	 TftWR_Str(100,100,DISPLAY,BLACK,WHITE);
}
//----------------------------------------//
void fm (void)
{
    unsigned char flag=1;  
    unsigned char count=0x01;
    unsigned char count_1=0x01;
    unsigned char num;
	unsigned char a,b,i;
    OSCILLATOR_Init1();  //ʱӳʼ
    Tft_Init();          //TFTʼ
    TftClear(WHITE);       //
//----------Ĭϵ̨87.4Mhz------------------------//
    pll=min_pll;
	get_frequency();
    radio_write_data[0]=pll/256; 
    radio_write_data[1]=pll%256; 
    radio_write_data[2]=0x20; 
    radio_write_data[3]=0x11; 
    radio_write_data[4]=0x00; 
    radio_write(); 
	display_chang();
//-------------------------------------------------   
	while (s2==1)
	{
		if(s1==0)                           //Զ̨ʵֲ洢EEPROM
		{
			for(i=0;i<50;i++)
			{
				delay_ms(300);
			}
			if(s1==0)		
			{
				while(s1==0);
				flag=!flag;
			}

		}

		else
		{
		if(flag==0)
		{	auto_search();                  
			display_chang();
			delay_ms(1000);
			radio_read();
			get_pll();
			write_24c(count,pll/256);
			delay_ms(500);
			count++;
			write_24c(count,pll%256);
			count++;
			num=count/2;
			write_24c(0x00,num);
			if((radio_read_data[0]&0x40))
			{
				flag=1;
				break;
			}
		
		}
		else
		{
			if(s0==0)                         //EEPROMѡȡѾõĵ̨
			{
				iic_delay(5);
				if(s0==0)
				{
					while(s0==0);
					a=read_24c(count_1);
					count_1++;
					delay_ms(50);
					b=read_24c(count_1);
					count_1++;
					num=read_24c(0x00);
					if(count_1>2*num)
					{
						count_1=0x01;
					}
					radio_write_data[0]=a;
					radio_write_data[1]=b;
					radio_write_data[2]=0x20;    
					radio_write_data[3]=0x11;
					radio_write_data[4]=0x00;
					radio_write();
					radio_read();
					display_chang();
				}	
			}
			if(s3==0)                         //EEPROMѡȡѾõĵ̨
			{
				iic_delay(5);
				if(s3==0)
				{
					while(s3==0);
					num=read_24c(0x00);
					if(count_1<0x02)
					{
						count_1=2*num;
					}
					a=read_24c(count_1);
					count_1--;
					delay_ms(50);
					b=read_24c(count_1);
					count_1--;
					radio_write_data[0]=a;
					radio_write_data[1]=b;
					radio_write_data[2]=0x20;    
					radio_write_data[3]=0x11;
					radio_write_data[4]=0x00;
					radio_write();
					radio_read();
					display_chang();
				}	
			}		         
		}
		}                 
	 }                                   // end of while(1)
}                                      // end of main()
